Index: main/java/org/drools/examples/sudoku/rules/RemovedCellBase.java
===================================================================
--- main/java/org/drools/examples/sudoku/rules/RemovedCellBase.java	(revision 0)
+++ main/java/org/drools/examples/sudoku/rules/RemovedCellBase.java	(revision 0)
@@ -0,0 +1,74 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.drools.examples.sudoku.rules;
+
+/**
+ * An abstract class which contains the methods common to both a GuessedCellValue
+ * and RemovedCellValue. Stores the possible cell that is removed by a guessing cycle
+ * and the resolved cell (if any) that was inserted in its place.
+ * It also overrides the methods of AbstractCellValue to return the location
+ * and value of the PossibleCellValue that was removed.
+ * 
+ * @author <a href="">Ted Keenan</a>
+ * @version $Revision: 1.1 $
+ */
+public abstract class RemovedCellBase
+   extends AbstractCellValue
+{
+	PossibleCellValue cellRemoved; 
+	ResolvedCellValue cellResolved;
+   /**
+    * Uses the constructor on the superclass to construct a new RemovedCellBase
+    * 
+    * @param cellValue the PossibleCellValue that was removed 
+    * @param resolvedCell the ResolvedCellValue that was inserted in its place, default = null
+    */   
+   public RemovedCellBase(PossibleCellValue cellValue , ResolvedCellValue  resolvedCell)
+   {
+      super(cellValue);
+      cellRemoved = cellValue;
+      this.cellResolved = resolvedCell;
+   }
+   /**
+    * Uses the constructor on the superclass to construct a new RemovedCellBase
+    * 
+    * @param cellValue the PossibleCellValue that was removed
+    */  
+   
+   public RemovedCellBase(PossibleCellValue cellValue )  
+   {
+	   this(cellValue,null);
+   }
+   /**
+    * The PossibleCellValue that was removed to create the cell
+    *  
+    * @return PossibleCellValue
+    */
+   public PossibleCellValue getPossibleCellRemoved()
+   {
+	      return  cellRemoved;	   
+   }
+   
+   /**
+    * The ResolvedCellValue that was created when the cell was removed
+    *  
+    * @return ResolvedCellValue 
+    */
+   public ResolvedCellValue getResolvedCell()
+   {
+	      return  cellResolved;	   
+   }
+   /**
+    * boolean to indicate if there was a resolved cell created when the removed
+    * cell was created
+    *  
+    * @return cellResolved != null
+    */
+   public boolean hasResolvedCell(){
+	   return (cellResolved != null);
+   }
+}
Index: main/java/org/drools/examples/sudoku/rules/RemovedCellValue.java
===================================================================
--- main/java/org/drools/examples/sudoku/rules/RemovedCellValue.java	(revision 0)
+++ main/java/org/drools/examples/sudoku/rules/RemovedCellValue.java	(revision 0)
@@ -0,0 +1,37 @@
+package org.drools.examples.sudoku.rules;
+
+/**
+ * Object for tracking cells removed during the logical testing of a guess. 
+ * Each removed cell is a single, possible value for a given cell,
+ * used when we are testing a guessing scenario.
+ * There is a single RemovedCellValue object associated with each removed possible
+ * Cell and potentially a resolved cell associated with the guessing rules.
+ * Guessed cells extends RemovedCellBase which has the classes to track which
+ * possible cells were removed to create the guess
+ * 
+ * @author <a href="">Ted Keenan</a>
+ * @version $Revision: 1.1 $
+ */
+public class RemovedCellValue extends RemovedCellBase {
+
+	   /**
+	    * Uses the constructor on the superclass to construct a new RemovedCellValue
+	    * 
+	    * @param cellValue the possible cell removed by the guessing rule
+	    * @param resolvedCell the resolve cell created by the guessing rule
+	    */
+	public RemovedCellValue(PossibleCellValue cellValue,
+			ResolvedCellValue resolvedCell) {
+		super(cellValue, resolvedCell);
+	}
+
+	   /**
+	    * Uses the constructor on the superclass to construct a new RemovedCellValue
+	    * 
+	    * @param cellValue the possible cell removed by the guessing rule
+	    */
+	public RemovedCellValue(PossibleCellValue cellValue) {
+		super(cellValue);
+	}
+
+}
Index: main/java/org/drools/examples/sudoku/rules/SudokuStatusConflict.java
===================================================================
--- main/java/org/drools/examples/sudoku/rules/SudokuStatusConflict.java	(revision 0)
+++ main/java/org/drools/examples/sudoku/rules/SudokuStatusConflict.java	(revision 0)
@@ -0,0 +1,20 @@
+package org.drools.examples.sudoku.rules;
+/**
+ * Represents a SudokuStatusMessage indicating a conflict.
+ * 
+ * @author 
+ * @version $Revision: 1.1 $
+ */
+
+public class SudokuStatusConflict extends SudokuStatusMessage {
+	 /**
+	    * Uses the constructor on the superclass to construct a new SudokuStatusConflict 
+	    * 
+	    * @param message the message associated with the issue
+	 */
+	public SudokuStatusConflict(String message) {
+		super(message);
+	}
+	
+
+}
Index: main/java/org/drools/examples/sudoku/rules/SudokuStatusMessage.java
===================================================================
--- main/java/org/drools/examples/sudoku/rules/SudokuStatusMessage.java	(revision 0)
+++ main/java/org/drools/examples/sudoku/rules/SudokuStatusMessage.java	(revision 0)
@@ -0,0 +1,51 @@
+/**
+ * 
+ */
+package org.drools.examples.sudoku.rules;
+
+/**
+ * An abstract class which contains the methods common objects used to 
+ * trace the status of the solution
+ * 
+ * @author 
+ * @version $Revision: 1.1 $
+ *
+ */
+public abstract class SudokuStatusMessage 
+{
+	   // The Status message
+	   private String message;
+	   
+	   
+	   /**
+	    * Create a new SudokuStatusMessage with the specified message.
+	    * 
+	    * @param message the message for the status
+	    */
+	   protected SudokuStatusMessage (String message)
+	   {
+	      this.message = message;
+	   }
+	   
+	   /**
+	    * Return the message
+	    * 
+	    * @return text of the message
+	    */
+	   public String getMessage()
+	   {
+	      return message;
+	   }
+	   /**
+	    * Return the type of message and the message
+	    * 
+	    * @return type and message
+	    */
+       public String toString()
+       {
+    	   Class<? extends SudokuStatusMessage> tmp = this.getClass();
+           String name = tmp.getName();
+       
+    	   return name + " : " + message;       
+       }
+}
Index: main/java/org/drools/examples/sudoku/rules/SudokuStatusSolved.java
===================================================================
--- main/java/org/drools/examples/sudoku/rules/SudokuStatusSolved.java	(revision 0)
+++ main/java/org/drools/examples/sudoku/rules/SudokuStatusSolved.java	(revision 0)
@@ -0,0 +1,19 @@
+package org.drools.examples.sudoku.rules;
+/**
+ * Represents a SudokuStatusMessage indicating the grid has been solved.
+ * 
+ * @author 
+ * @version $Revision: 1.1 $
+ */
+
+public class SudokuStatusSolved extends SudokuStatusMessage {
+	 /**
+	    * Uses the constructor on the superclass to construct a new SudokuStatusConflict 
+	    * 
+	    * @param message the message associated with the issue
+	 */
+	public SudokuStatusSolved(String message) {
+		super(message);
+	}
+
+}
Index: main/java/org/drools/examples/sudoku/rules/SudokuStatusUnresolved.java
===================================================================
--- main/java/org/drools/examples/sudoku/rules/SudokuStatusUnresolved.java	(revision 0)
+++ main/java/org/drools/examples/sudoku/rules/SudokuStatusUnresolved.java	(revision 0)
@@ -0,0 +1,51 @@
+package org.drools.examples.sudoku.rules;
+/**
+ * Represents a SudokuStatusMessage indicating a cell with multiple possible values.
+ * 
+ * @author 
+ * @version $Revision: 1.1 $
+ */
+
+public class SudokuStatusUnresolved extends SudokuStatusMessage {
+/**
+ * The cell that is unresolved
+ */
+	private BaseCell baseCell; 
+	
+	 /**
+	    * Uses the constructor on the superclass to construct a new SudokuStatusUnresolved
+	    * The cell that is unresolved 
+	    * 
+	    * @param message the message associated with the issue
+	 */
+	public SudokuStatusUnresolved(String message,BaseCell baseCell) {
+		super(message);
+		this.baseCell = baseCell;
+	}
+	/**
+	 * The cell that isn't resolved
+	 * @return
+	 */
+	public BaseCell getBase()
+	{
+		return baseCell;
+	}
+	/**
+	 * The id of the row that is unresolved
+	 * @return The id of the row that is unresolved
+	 */
+	public int getRow()
+	{
+		return baseCell.getRow();
+	}
+	/**
+	 * The id of the col that is unresolved
+	 * 
+	 * @return The id of the col that is unresolved
+	 */
+	public int getCol()
+	{
+		return baseCell.getCol();
+	}
+
+}
Index: main/java/org/drools/examples/sudoku/swing/GridModelConstants.java
===================================================================
--- main/java/org/drools/examples/sudoku/swing/GridModelConstants.java	(revision 0)
+++ main/java/org/drools/examples/sudoku/swing/GridModelConstants.java	(revision 0)
@@ -0,0 +1,23 @@
+package org.drools.examples.sudoku.swing;
+
+import java.util.Map;
+
+public interface GridModelConstants {
+
+	public abstract int getNumRows();
+
+	public abstract int getNumCols();
+
+	public abstract int getInnerGridHeight();
+
+	public abstract int getInnerGridWidth();
+
+	public abstract int[][] getZoneLookup();
+	
+	public abstract boolean isFourByFour();
+	public abstract boolean isSixBySix();
+	public abstract boolean isNineByNine();
+	public abstract Map<String, Integer[][]> getSamples();
+
+	
+}
\ No newline at end of file
Index: main/java/org/drools/examples/sudoku/swing/SudokuGridModelConstants.java
===================================================================
--- main/java/org/drools/examples/sudoku/swing/SudokuGridModelConstants.java	(revision 0)
+++ main/java/org/drools/examples/sudoku/swing/SudokuGridModelConstants.java	(revision 0)
@@ -0,0 +1,163 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.drools.examples.sudoku.swing;
+
+import java.lang.reflect.Constructor;
+import java.lang.reflect.InvocationTargetException;
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Set;
+
+
+/**
+ * A generic interface representing a 4x4 or a 9x9 Sudoku Grid of Cells.
+ * <p>
+ * In a solved Sudoku grid, each cell must contain an 
+ * integer from 1-grid width and the same integer must not be 
+ * repeated in the same row, in the same column or in 
+ * the same subsection of the grid.
+ * 
+ * @see SudokuGridListener
+ * @see SudokuGridEvent
+ * @see SudokuGridView
+ * @see AbstractSudokuGridModel
+ * @author <a href="pbennett@redhat.com">Pete Bennett</a>
+ * @version $Revision: 1.1 $
+ */
+public class SudokuGridModelConstants implements GridModelConstants 
+{ 	
+	protected static SudokuGridModelConstants INSTANCE;
+
+   /* (non-Javadoc)
+ * @see org.drools.examples.sudoku.swing.GridModelConstance#getNUM_ROWS()
+ */
+	protected GridModelConstants modelConstants;
+	   public static SudokuGridModelConstants getInstance()
+	   {
+	      if (INSTANCE == null)
+	      {
+	         INSTANCE = new SudokuGridModelConstants();
+	      }
+	      
+	      return INSTANCE;
+	   }
+
+	/**
+	 * Constructor for the constants that initializes either the 4x4 or 9x9
+	 * strategy   
+	 */
+	public SudokuGridModelConstants ()
+	{
+		modelConstants =  new SudokuGridModelConstants6x6();
+	}
+	public int getInnerGridHeight() {
+		return modelConstants.getInnerGridHeight();
+	}
+
+	@Override
+	public int getInnerGridWidth() {
+		return modelConstants.getInnerGridWidth();
+	}
+
+	@Override
+	public int getNumCols() {
+		return modelConstants.getNumCols();
+	}
+
+	@Override
+	public int getNumRows() {
+		return modelConstants.getNumRows();
+	}
+
+	@Override
+	public int[][] getZoneLookup() {
+		return modelConstants.getZoneLookup();
+	}
+	public boolean isFourByFour()
+	{
+		return modelConstants.isFourByFour();
+	}
+	   public boolean isSixBySix()
+		{
+			return modelConstants.isSixBySix();
+		}
+
+	public boolean isNineByNine()
+	{
+		return modelConstants.isNineByNine();
+	}
+	public int getTop(int row)
+	{
+		return (row % getInnerGridHeight() == 0 ? (getInnerGridHeight()-1) : 0); 
+	}
+	
+	public int getLeft(int col)
+	{
+		return (col % getInnerGridWidth () == 0 ? (getInnerGridWidth ()-1) : 0); 
+	}
+	
+	public int getBottom(int row)
+	{
+		return (row == getNumRows()-1 ? (getInnerGridHeight()-1) : 0); 
+	}
+	
+	public int getRight(int col)
+	{
+		return (col == getNumCols()-1 ? (getInnerGridWidth ()-1) : 0); 
+	}
+
+	public void setConstantType(String string){
+		 try {
+				Class cls ;
+		         Constructor ct ;
+	            Object retobj ;
+				cls = Class.forName("org.drools.examples.sudoku.swing.SudokuGridModelConstants" + string);
+		        ct = cls.getConstructor();
+	            retobj = ct.newInstance();
+	    		this.modelConstants = (GridModelConstants) retobj ;
+	        } catch (ClassNotFoundException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			} catch (SecurityException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			} catch (NoSuchMethodException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			} catch (IllegalArgumentException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			} catch (InstantiationException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			} catch (IllegalAccessException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			} catch (InvocationTargetException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+
+	}
+
+	@Override
+	public Map<String, Integer[][]> getSamples() {
+		// TODO Auto-generated method stub
+		return modelConstants.getSamples();
+	}
+
+	public Set<String> getSampleNames()
+	   {
+	      return modelConstants.getSamples().keySet();
+	   }
+	   
+	   public Integer[][] getSample(String name)
+	   {
+	      return modelConstants.getSamples().get(name);
+	   }
+
+ }
Index: main/java/org/drools/examples/sudoku/swing/SudokuGridModelConstants4x4.java
===================================================================
--- main/java/org/drools/examples/sudoku/swing/SudokuGridModelConstants4x4.java	(revision 0)
+++ main/java/org/drools/examples/sudoku/swing/SudokuGridModelConstants4x4.java	(revision 0)
@@ -0,0 +1,139 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.drools.examples.sudoku.swing;
+
+import java.util.HashMap;
+import java.util.Map;
+
+/**
+ * An interface representing a 4x4 Sudoku Grid of Cells.
+ * <p>
+ * In a solved Sodoku grid, each cell must contain an 
+ * integer from 1-4 and the same integer must not be 
+ * repeated in the same row, in the same column or in 
+ * the same 2x2 subsection of the grid.
+ * 
+ * @see SudokuGridListener
+ * @see SudokuGridEvent
+ * @see SudokuGridView
+ * @see AbstractSudokuGridModel
+ * @author 
+ * @version $Revision: 1.1 $
+ */
+public class SudokuGridModelConstants4x4 implements GridModelConstants 
+{ 	
+	   private Map<String, Integer[][]> samples = new HashMap<String, Integer[][]>();
+
+   protected static int NUM_ROWS = 4;
+
+   /**
+    * The number of columns in the Grid, i.e. the width
+    */
+   protected static int NUM_COLS = 4;
+   
+   /**
+    * The number of cells in a column
+    */
+   protected static int INNER_GRID_HEIGHT = 2;
+   
+   /**
+    * The number of cells in a row
+    */
+   protected  static int INNER_GRID_WIDTH = 2;   
+   
+   /**
+    * A NUM_ROWSxNUM_COLS two dimensional array which maps from rows and columns
+    * to the 2x2 subzones in a Sudoku grid
+    */
+   protected  static int[][] ZONE_LOOKUP = 
+   { { 1 , 1 ,  2 , 2 },
+	 { 1 , 1 ,  2 , 2 },
+	 { 3 , 3 ,  4 , 4 },
+	 { 3 , 3 ,  4 , 4 },
+	 };  
+
+   public SudokuGridModelConstants4x4(){
+		super();
+		   /**
+		    * The number of rows in the Grid, i.e. the height
+		    */      // these are 4x4 samples
+		    samples.put
+		    (
+		      "Simple",
+		      new Integer[][] 
+		     {
+		      {4, null, 2, 3},
+		      {null, 2, 1, 4},
+		      {null, null, 4, null},
+		      {2, 4, 3, 1}
+		      }
+		    );
+		    samples.put
+		    (
+		  		  "!Indeterminate!",
+		  	       new Integer[][] 
+		 		       {
+		 		        {null, null, 4, null},
+		 		        {4, null, null, 3},
+		 		        {null, null, null, 4},
+		 		        {2, 4, 3, 1}
+		 		        }
+		    );
+		    
+		    samples.put
+		    (
+		  		  "!DELIBERATELY BROKEN!",
+		  	               new Integer[][] 
+		 		       {
+		 		        {null, null, 4, null},
+		 		        {4, null, 2, 3},
+		 		        {null, 2, 1, 4},
+		 		        {2, 4, 3, 1}
+		 		        }
+		    );
+		 
+	   
+   }
+   public int getNumRows() {
+   		return NUM_ROWS;
+   	}
+
+   public int getNumCols() {
+   		return NUM_COLS;
+   	}
+
+   	public int getInnerGridHeight() {
+   		return INNER_GRID_HEIGHT;
+   	}
+
+   	public int getInnerGridWidth() {
+   		return INNER_GRID_WIDTH;
+   	}
+
+   	public int[][] getZoneLookup() {
+   		return ZONE_LOOKUP;
+   	}
+
+   public boolean isFourByFour()
+	{
+		return true;
+	}
+   public boolean isSixBySix()
+	{
+		return false;
+	}
+   public boolean isNineByNine()
+	{
+		return false;
+	}
+
+@Override
+public Map<String, Integer[][]> getSamples() {
+	// TODO Auto-generated method stub
+	return samples;
+}
+}
Index: main/java/org/drools/examples/sudoku/swing/SudokuGridModelConstants6x6.java
===================================================================
--- main/java/org/drools/examples/sudoku/swing/SudokuGridModelConstants6x6.java	(revision 0)
+++ main/java/org/drools/examples/sudoku/swing/SudokuGridModelConstants6x6.java	(revision 0)
@@ -0,0 +1,159 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.drools.examples.sudoku.swing;
+
+import java.util.HashMap;
+import java.util.Map;
+
+/**
+ * An interface representing a 6x6 Sudoku Grid of Cells.
+ * <p>
+ * In a solved Sodoku grid, each cell must contain an 
+ * integer from 1-6 and the same integer must not be 
+ * repeated in the same row, in the same column or in 
+ * the same 2x2 subsection of the grid.
+ * 
+ * @see SudokuGridListener
+ * @see SudokuGridEvent
+ * @see SudokuGridView
+ * @see AbstractSudokuGridModel
+ * @author 
+ * @version $Revision: 1.1 $
+ */
+public class SudokuGridModelConstants6x6 implements GridModelConstants 
+{ 	
+	   private Map<String, Integer[][]> samples = new HashMap<String, Integer[][]>();
+
+   protected static int NUM_ROWS = 6;
+
+   /**
+    * The number of columns in the Grid, i.e. the width
+    */
+   protected static int NUM_COLS = 6;
+   
+   /**
+    * The number of cells in a column
+    */
+   protected static int INNER_GRID_HEIGHT = 3;
+   
+   /**
+    * The number of cells in a row
+    */
+   protected  static int INNER_GRID_WIDTH = 2;   
+   
+   /**
+    * A NUM_ROWSxNUM_COLS two dimensional array which maps from rows and columns
+    * to the 2x2 subzones in a Sudoku grid
+    */
+   protected  static int[][] ZONE_LOOKUP = 
+   { { 1 , 1 ,  2 , 2 , 3 , 3 },
+	 { 1 , 1 ,  2 , 2 , 3 , 3 },
+	 { 1 , 1 ,  2 , 2 , 3 , 3 },
+	 { 4 , 4 , 5 , 5 ,  6 , 6 },
+	 { 4 , 4 , 5 , 5 ,  6 , 6 },
+	 { 4 , 4 , 5 , 5 ,  6 , 6 }
+	 };  
+
+   public SudokuGridModelConstants6x6(){
+		super();
+		   /**
+		    * The number of rows in the Grid, i.e. the height
+		    */      // these are 6x6 samples
+		    samples.put
+		    (
+			        "!DELIBERATELY BROKEN!",
+		      new Integer[][] 
+		     {
+		      {6, null, 2, 3,4,5},
+		      {4,5,null, 2, 1, 6},
+		      {null, null,null, null, null, null},
+		      {null, null,6,null, null,  null},
+		      {null, null,null, null,6, null},
+		      {2, 6, 4,5,3, 1}
+		      }
+		    );
+		    samples.put
+		    (
+		     "!Indeterminate!",
+		     new Integer[][] 
+		     {
+		      {6, null, 2, 3,4, null},
+		      {4,null,null, 5, null,  null},
+		      {null, null,null, 6,null,  null},
+		      {null, null,6,null, null,  null},
+		      {null, null,null,null, null, 4},
+		      {2, 6, null,4,null, null}
+		      }
+		    );
+		    samples.put
+		    (
+		      "Hard",
+		      new Integer[][] 
+		     {
+		      {6, null, 2, 3,4, null},
+		      {4,null,null, 5, null,  null},
+		      {null, null,null, 6,null,  null},
+		      {null, null,6,null, null,  null},
+		      {null, null,null,null, null, 4},
+		      {2, 6, null,4,5, null}
+		      }
+		    );
+		    samples.put
+		    (
+		      "Simple",
+		      new Integer[][] 
+		     {
+		      {6, 1, 2, 3,4, null},
+		      {4,null,null, 5, null,  null},
+		      {null, null,null, 6,null,  2},
+		      {null, null,6,1, null,  3},
+		      {1, null,null,null, null, 4},
+		      {2, 6, null,4,5, null}
+		      }
+		    );
+
+	   
+   }
+   public int getNumRows() {
+   		return NUM_ROWS;
+   	}
+
+   public int getNumCols() {
+   		return NUM_COLS;
+   	}
+
+   	public int getInnerGridHeight() {
+   		return INNER_GRID_HEIGHT;
+   	}
+
+   	public int getInnerGridWidth() {
+   		return INNER_GRID_WIDTH;
+   	}
+
+   	public int[][] getZoneLookup() {
+   		return ZONE_LOOKUP;
+   	}
+
+   public boolean isFourByFour()
+	{
+		return false;
+	}
+   public boolean isSixBySix()
+	{
+		return true;
+	}
+   public boolean isNineByNine()
+	{
+		return false;
+	}
+
+@Override
+public Map<String, Integer[][]> getSamples() {
+	// TODO Auto-generated method stub
+	return samples;
+}
+}
Index: main/java/org/drools/examples/sudoku/swing/SudokuGridModelConstants9x9.java
===================================================================
--- main/java/org/drools/examples/sudoku/swing/SudokuGridModelConstants9x9.java	(revision 0)
+++ main/java/org/drools/examples/sudoku/swing/SudokuGridModelConstants9x9.java	(revision 0)
@@ -0,0 +1,232 @@
+/*
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.drools.examples.sudoku.swing;
+
+import java.util.HashMap;
+import java.util.Map;
+
+/**
+ * An interface representing a 9x9 Sudoku Grid of Cells.
+ * <p>
+ * In a solved Sodoku grid, each cell must contain an 
+ * integer from 1-9 and the same integer must not be 
+ * repeated in the same row, in the same column or in 
+ * the same 3x3 subsection of the grid.
+ * 
+ * @see SudokuGridListener
+ * @see SudokuGridEvent
+ * @see SudokuGridView
+ * @see AbstractSudokuGridModel
+ * @author <a href="pbennett@redhat.com">Pete Bennett</a>
+ * @version $Revision: 1.1 $
+ */
+public class SudokuGridModelConstants9x9 implements GridModelConstants
+{ 
+	   private Map<String, Integer[][]> samples = new HashMap<String, Integer[][]>();
+	   /**
+	    * The number of rows in the Grid, i.e. the height
+	    */
+	   public static int NUM_ROWS = 9;
+
+	   /**
+	    * The number of columns in the Grid, i.e. the width
+	    */
+	   public static int NUM_COLS = 9;
+	   
+	   /**
+	    * The number of cells in a column
+	    */
+	   protected static int INNER_GRID_HEIGHT = 3;
+	   
+	   /**
+	    * The number of cells in a row
+	    */
+	   public static int INNER_GRID_WIDTH = 3;   
+	   
+	   /**
+	    * A NUM_ROWSxNUM_COLS two dimensional array which maps from rows and columns
+	    * to the 3x3 subzones in a Sudoku grid
+	    */
+	   public static int[][] ZONE_LOOKUP = 
+	   { { 1 , 1 , 1 , 2 , 2 , 2 , 3 , 3 , 3},
+	     { 1 , 1 , 1 , 2 , 2 , 2 , 3 , 3 , 3},
+	     { 1 , 1 , 1 , 2 , 2 , 2 , 3 , 3 , 3},
+	     { 4 , 4 , 4 , 5 , 5 , 5 , 6 , 6 , 6},
+	     { 4 , 4 , 4 , 5 , 5 , 5 , 6 , 6 , 6},
+	     { 4 , 4 , 4 , 5 , 5 , 5 , 6 , 6 , 6},
+	     { 7 , 7 , 7 , 8 , 8 , 8 , 9 , 9 , 9},
+	     { 7 , 7 , 7 , 8 , 8 , 8 , 9 , 9 , 9},
+	     { 7 , 7 , 7 , 8 , 8 , 8 , 9 , 9 , 9} };
+	   public SudokuGridModelConstants9x9 (){
+		   samples.put
+		      (
+		        "Simple",
+		        new Integer[][] 
+		       {{null, 5, 6, 8, null, 1, 9, 4, null},
+		        {9, null, null, 6, null, 5, null, null, 3},
+		        {7, null, null, 4, 9, 3, null, null, 8},
+		        {8, 9, 7, null, 4, null, 6, 3, 5},
+		        {null, null, 3, 9, null, 6, 8, null, null},
+		        {4, 6, 5, null, 8, null, 2, 9, 1},
+		        {5, null, null, 2, 6, 9, null, null, 7},
+		        {6, null, null, 5, null, 4, null, null, 9},
+		        {null, 4, 9, 7, null, 8, 3, 5, null}}
+		      );
+		      
+		      samples.put
+		      (
+		        "Medium",
+		        new Integer[][] 
+		       {{8, 4, 7, null, null, null, 2, 5, 6},
+		               {5, null, null, null, 8, null, null, null, 4},
+		               {2, null, null, null, 7, null, null, null, 8},
+		               {null, null, null, 3, null, 8, null, null, null},
+		               {null, 5, 1, null, null, null, 8, 7, 2},
+		               {null, null, null, 5, null, 7, null, null, null},
+		               {4, null, null, null, 5, null, null, null, 7},
+		               {6, null, null, null, 3, null, null, null, 9},
+		               {1, 3, 2, null, null, null, 4, 8, 5}}
+		      );
+		      
+		      samples.put
+		      (
+		        "Hard 1",
+		        new Integer[][] 
+		       {{null, null, null, null, 5, 1, null, 8, null},
+		               {null, 8, null, null, 4, null, null, null, 5},
+		               {null, null, 3, null, null, null, 2, null, null},
+		               {null, null, null, null, 6, null, null, null, 9},
+		               {6, 7, null, 4, null, 9, null, 1, 3},
+		               {8, null, null, null, 3, null, null, null, null},
+		               {null, null, 2, null, null, null, 4, null, null},
+		               {5, null, null, null, 9, null, null, 2, null},
+		               {null, 9, null, 7, 1, null, null, null, null}}
+		      );
+		      
+		      samples.put
+		      (
+		        "Hard 2",
+		        new Integer[][] 
+		       {{null,null,null,6,null,null,1,null,null},
+		           {null,null,null,null,null,5,null,null,6},
+		           {5,null,7,null,null,null,2,3,null},
+		           {null,8,null,9,null,7,null,null,null},
+		           {9,3,null,null,null,null,null,6,7},
+		           {null,null,null,4,null,6,null,1,null},
+		           {null,7,4,null,null,null,9,null,1},
+		           {8,null,null,7,null,null,null,null,null},
+		           {null,null,3,null,null,8,null,null,null}}
+		      );
+
+		      samples.put
+		      (
+		        "Hard 3",
+		        new Integer[][] 
+		       {{null,8,null,null,null,6,null,null,5},
+		               {2,null,null,null,null,null,4,8,null},
+		               {null,null,9,null,null,8,null,1,null},
+		               {null,null,null,null,8,null,1,null,2},
+		               {null,null,null,3,null,1,null,null,null},
+		               {6,null,1,null,9,null,null,null,null},
+		               {null,9,null,4,null,null,8,null,null},
+		               {null,7,6,null,null,null,null,null,3},
+		               {1,null,null,7,null,null,null,5,null}}
+		      );
+		      
+		      samples.put
+		      (
+		        "Hard 4",
+		        new Integer[][] 
+		       {{null,null,null,null,null,4,null,9,5},
+		               {6,7,null,5,null,null,null,1,null},
+		               {null,null,null,6,null,9,null,null,null},
+		               {null,2,null,null,null,null,4,null,null},
+		               {8,1,null,null,null,null,null,7,2},
+		               {null,null,7,null,null,null,null,8,null},
+		               {null,null,null,3,null,5,null,null,null},
+		               {null,6,null,null,null,1,null,5,8},
+		               {7,3,null,9,null,null,null,null,null}}
+		      );    
+		      
+		      samples.put
+		      (
+		        "!DELIBERATELY BROKEN!",
+		        new Integer[][] 
+		       {{5,null,null,null,null,4,null,9,5},
+		               {6,7,null,5,null,null,null,1,null},
+		               {null,null,null,6,null,9,null,null,null},
+		               {null,2,null,null,null,null,4,null,null},
+		               {8,1,null,null,null,null,null,7,2},
+		               {null,null,7,null,null,null,null,8,null},
+		               {8,null,null,3,null,5,null,null,null},
+		               {null,6,null,null,null,1,null,5,8},
+		               {7,3,null,9,null,null,null,null,null}}
+			   
+		      );
+		      samples.put
+		      (
+		        "Today",
+		        new Integer[][] 
+		       {
+		        	{null,null,8,5,null,null,null,2,7},
+		        	{2,null,6,null,null,null,null,null,null},
+		        	{null,null,null,null,7,null,3,null,null},
+		        	{4,null,null,null,5,3,null,6,null},
+		        	{null,null,9,null,null,null,4,null,null},
+		        	{null,8,null,1,9,null,null,null,3},
+		        	{null,null,2,null,8,null,null,null,null},
+		        	{null,null,null,null,null,null,9,null,5},
+		        	{9,6,null,null,null,7,8,null,null}
+		               }
+			   
+		      );
+
+	   }
+
+	   public int getNumRows() {
+			return NUM_ROWS;
+		}
+
+	public int getNumCols() {
+			return NUM_COLS;
+		}
+
+
+	public int getInnerGridHeight() {
+			return INNER_GRID_HEIGHT;
+		}
+
+	public int getInnerGridWidth() {
+			return INNER_GRID_WIDTH;
+		}
+
+	public int[][] getZoneLookup() {
+			return ZONE_LOOKUP;
+		}
+
+
+
+   public boolean isFourByFour()
+	{
+		return false;
+	}
+   
+   public boolean isSixBySix()
+	{
+		return false;
+	}
+	public boolean isNineByNine()
+	{
+		return true;
+	}
+
+	@Override
+	public Map<String, Integer[][]> getSamples() {
+		// TODO Auto-generated method stub
+		return samples;
+	}
+
+}
Index: main/java/org/drools/examples/sudoku/swing/SudokuGridModelInterface.java
===================================================================
--- main/java/org/drools/examples/sudoku/swing/SudokuGridModelInterface.java	(revision 0)
+++ main/java/org/drools/examples/sudoku/swing/SudokuGridModelInterface.java	(revision 0)
@@ -0,0 +1,44 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.drools.examples.sudoku.swing;
+
+import java.util.List;
+import java.util.Set;
+
+/**
+ * An interface representing a 9x9 Sudoku Grid of Cells.
+ * <p>
+ * In a solved Sodoku grid, each cell must contain an 
+ * integer from 1-9 and the same integer must not be 
+ * repeated in the same row, in the same column or in 
+ * the same 3x3 subsection of the grid.
+ * 
+ * @see SudokuGridListener
+ * @see SudokuGridEvent
+ * @see SudokuGridView
+ * @see AbstractSudokuGridModel
+ * @author <a href="pbennett@redhat.com">Pete Bennett</a>
+ * @version $Revision: 1.1 $
+ */
+public interface SudokuGridModelInterface
+{ 
+   public void setCellValues(Integer[][] cellValues);
+   
+   public boolean isCellEditable(int row, int col);
+   
+   public boolean isCellResolved(int row, int col);
+   
+   public Set<Integer> getPossibleCellValues(int row, int col);
+   
+   public boolean solve();
+   
+   public boolean isGridSolved();
+   
+   public void addSudokuGridListener(SudokuGridListener l);   
+   
+   public void removeSudokuGridListener(SudokuGridListener l);
+}
